
/*  A Bison parser, made from pddl.yacc
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NAME	257
#define	OPEN_BRAC	258
#define	CLOSE_BRAC	259
#define	PRE	260
#define	DEFINE	261
#define	REQS	262
#define	DOMAIN	263
#define	STRIPS	264
#define	CONSTANTS	265
#define	PREDS	266
#define	PROBLEM	267
#define	INITIALLY	268
#define	GOALS	269
#define	ACTION	270
#define	ARGS	271
#define	EFFECTS	272
#define	NOT	273
#define	Q	274
#define	STATICS	275
#define	AND	276
#define	DEL	277
#define	SITUATION	278
#define	FORDOMAIN	279
#define	VARS	280
#define	EQ	281
#define	LENGTH	282
#define	PARALLEL	283
#define	SERIAL	284

#line 3 "pddl.yacc"

/* 
* $Revision: 3.6 $
* $Date: 1999/07/09 22:17:57 $
*
*/

extern int printf(const char *,...);
extern void * malloc();
extern void free(void *);

#include <ctype.h>
#include "alldefs.h"

int yyerror(char *);
extern int yylex();


/* These globals store the main collections of data produced by the parser. */

domptr topdom;
predlist allpreds;


/* Variables used in PDDL to check that domain and problem names match. */

char * dname;
char * pname;


/* Value used because PDDL STRIPS has no types. */
 
char * notype = "";



/* Track whether we are reading operators or problem spec. - constants have to
handled slightly differently in each case. */

int pstate = 0;


/* Store variables declared in an operator, and the extras generated by abstracting
constants appearing in operators. */

tpptr ml = 0;
tpptr alex = 0;


/* Store constants as they are read in. */

tpptr cur_obs = 0;
tpptr cur_obs1;


/* Variables used to track the (not (= ...)) preconditions and the propositions 
created when abstracting constants from operators. */

plptr uneqpairs = 0;
plptr extraprops = 0;
plptr allextraprops = 0;

/* Variables list */

tpptr vl = 0;

extern int lineno;

void printrels(plptr);

void printpropn(propptr);

void initialiseParser()
{
	lineno = 0;
	uneqpairs = 0;
	allextraprops = 0;
	extraprops = 0;
	vl = 0;
	cur_obs = 0;
	pstate = 0;
	ml = 0;
	alex = 0;
};



void finishOps()
{
	pstate = 1;
};


/* Many of the following functions are simply used to construct the parsed
structures as they are read in. Very little of great interest is happening here. */

effptr
setelist(effptr lots,effptr one)
{
	if(one->adds)
	{	one->adds->rest = lots->adds;
		lots->adds = one->adds;
	}
	else
	{
		one->dels->rest = lots->dels;
		lots->dels = one->dels;
	};

	free(one);
	return lots;
};

effptr
setadd(propptr p)
{
	effptr x = (effptr) malloc(sizeof(struct efflist));
	x->adds = (plptr) malloc(sizeof(struct proplist));
	x->dels = 0;

	x->adds->rest = 0;
	x->adds->prop = p;
	return x;
};

effptr
setdel(propptr p)
{
	effptr x = (effptr) malloc(sizeof(struct efflist));
	x->dels = (plptr) malloc(sizeof(struct proplist));
	x->adds = 0;

	x->dels->rest = 0;
	x->dels->prop = p;
	return x;
};


oplistptr
setset(opptr o,oplistptr os)
{	oplistptr newseq = (oplistptr) malloc(sizeof(struct operator_set));
	newseq->op = o;
	newseq->ops = os;
	return newseq;
};



pptr
setpair(char * n,char * m)
{	pptr newpair = (pptr) malloc(sizeof(struct pair));
	newpair->varname = n;
	newpair->type_name = m;
	newpair->type[0] = 0;
	newpair->type[1] = 0;
	newpair->used = 0;
	newpair->isInPre = 0;

	return newpair;
};

predlist
setpred(char * n,int x)
{	predlist newcell = (predlist) malloc(sizeof(struct predcell));
	newcell->name = n;
	newcell->numargs = x;
	newcell->fr = 0;
	newcell->ar = 0;
	newcell->next = 0;
	newcell->initially = 0;
	return newcell;
};


tpptr
findfst(tpptr ts,char * nm1,char * nm2)
{
	for(;ts;ts=ts->tps)
	{	if(strcmp(ts->type->varname,nm1)==0)
			return ts;
		if(strcmp(ts->type->varname,nm2)==0)
			return ts;
	};

	printf("Error: variable unknown\n");
	return 0;
};

void
adduneq(tpptr ts,tpptr thefst,char * nm1,char * nm2)
{
	tpptr the_snd = 0;
	uneqlist newuneq;

	if(strcmp(thefst->type->varname,nm1)==0)
	{
		the_snd = findfst(ts,nm2,nm2);
	}
	else
	{
		the_snd = findfst(ts,nm1,nm1);
	};


	newuneq = (uneqlist) malloc(sizeof(struct uneqlistnode));
	newuneq->uneq = thefst;
	newuneq->next = the_snd->uneqs;
	the_snd->uneqs = newuneq;
};

tpptr
setdecls(pptr p,tpptr ts)
{	tpptr newdecls = (tpptr) malloc(sizeof(struct type_decls));
	newdecls->tps = ts;
	newdecls->type = p;
	newdecls->uneqs = 0;
	return newdecls;
};


tpptr 
appendvars(tpptr a,tpptr b)
{
	tpptr tmp=b;

	if(b==0) return a;

	for(;b->tps;b=b->tps);

	b->tps = a;

	return tmp;
};

opptr
setop(tpptr ts,opptr o)
{	
	tpptr the_first_var = 0;

	o->vars = ts;
	for(;uneqpairs>0;uneqpairs = uneqpairs->rest)
	{
		the_first_var = findfst(ts,uneqpairs->prop->nm->varname,uneqpairs->prop->as->nm->varname);
		adduneq(ts,the_first_var,uneqpairs->prop->nm->varname,uneqpairs->prop->as->nm->varname);
	};


	o->vars_shadow = o->vars;

	return o;
};


opptr
setoprels(plptr ps,plptr as,plptr ds)
{	opptr newop = (opptr) malloc(sizeof(struct operator_));
	newop->precs = ps;
	newop->adds = as;
	newop->dels = ds;
	newop->statics = extraprops; 

	if(ps && extraprops)
	{
		for(extraprops = ps;extraprops->rest;extraprops=extraprops->rest);

		extraprops->rest = newop->statics;
	}
	else
	{
		if(extraprops) newop->precs = extraprops;
	};

	extraprops = 0;
#ifdef MOBFILTER
	newop -> optype = 0;
	newop -> mobvars = 0;
	newop -> data = 0;
#endif
	return newop;
};

opptr
setopname(char * n,tpptr a,opptr o)
{

	tpptr xs = vl;
	propptr x;

	o->vars = a;
	o->thename = (propptr) malloc(sizeof(struct propn));
	o->thename->nm = (pptr) malloc(sizeof(struct pair));
	o->thename->nm->varname = n;
	o->thename->as = 0;
	for(;xs;xs=xs->tps)
	{
		x = (propptr) malloc(sizeof(struct propn));
		x->nm = xs->type;
		x->as = o->thename->as;
		o->thename->as = x;
	};
	return o;
};


plptr
setplist(plptr n,propptr p)
{	plptr newpl = (plptr) malloc(sizeof(struct proplist));
	newpl->rest = n;
	newpl->prop = p;
	return newpl;
};

propptr
setpropn(pptr n,propptr alist)
{	propptr newprop = (propptr) malloc(sizeof(struct propn));
	newprop->as = alist;
	newprop->nm = n;
	return newprop;
};

pptr 
findquery(char * v)
{	tpptr ptr = ml;
	while (ptr != 0)
	{	if (strcmp(ptr->type->varname,v)==0)
		{return ptr->type;};
		ptr=ptr->tps;
	};
	return 0;
};

int 
findalex(char * v)
{	tpptr ptr = alex;
	while (ptr != 0)
	{	if (strcmp(ptr->type->varname,v)==0)
		{return 1;};
		ptr=ptr->tps;
	};
	return 0;
};

predlist
insertpred(predlist, propptr,predlist);

pptr addextraprop(pptr c)
{
	propptr newp,newp1;
	plptr newp2;
	pptr newc;

	if(pstate) return c;

	newc = findquery(c->varname);

	if(newc) return newc;

	newc = setpair(c->varname,"101");
	newp = setpropn(newc,0);
	ml = setdecls(newc,ml);

	newp1 = setpropn(newc,newp);
	newp2 = (plptr) malloc(sizeof(struct proplist));
	newp2->rest = extraprops;
	newp2->prop = newp1;
	extraprops = newp2;

	if(!findalex(c->varname))
	{
		newp2 = (plptr) malloc(sizeof(struct proplist));
		newp2->rest = allextraprops;
		newp2->prop = newp1;
		allextraprops = newp2;
		alex = setdecls(newc,alex);

		allpreds = insertpred(setpred(c->varname,1),newp1,allpreds);
	};

	return newc;
};

void markUsedInOp(pptr c)
{
	if(!pstate) 
		c->used = 1;
};

	

propptr
setpropnargs(pptr n,propptr alist)
{	propptr alist2 = alist;
	propptr newprop = (propptr) malloc(sizeof(struct propn));
	newprop->as = 0;
	if(alist != 0)
	{	while (alist2->as != 0)
		{	alist2 = alist2->as;
		};
		alist2->as = newprop;
	}
	else
	{	alist = newprop;
	};
	newprop->nm = n;
	return alist;
};
	
domptr
make_domain(oplistptr os,plptr init,plptr gl)
{	domptr newdom = (domptr) malloc(sizeof(struct domain));
	newdom->ops = os;
	newdom->initial_state = init;
	newdom->goal_state = gl;
	newdom->statics = 0;

	return newdom;
};
	
domptr
add_to_domain(plptr init,plptr gl)
{
	topdom->initial_state = init;
	topdom->goal_state = gl;

	if(allextraprops) 	
	{
	  topdom->initial_state = allextraprops;
	  for(;allextraprops->rest;allextraprops=allextraprops->rest);

	  allextraprops->rest = init;

	};

  	allextraprops = init;

	return topdom;
};


/* The next group of functions are used in carrying out the fixed resource
analysis. This code preceded the code in TIM itself, so there is now some
overlap in the analysis - particularly the identification of deleted preconditions
and matching add effects. However, this analysis is concerned with predicates
rather than properties. */


int
checkMatch(propptr pre,propptr del)
{
	for(;pre;pre = pre->as)
	{
		if(strcmp(pre->nm->varname,del->nm->varname)) return 0;

		del=del->as;
	};

	return del==0;
};


plptr
exactMatch(propptr prp,plptr precs,plptr adds)
{
	/* Look for EXACT match between prp and something in precs.
	If it's there and also there is a match with the predicate
	in adds then return the adds pointing at next thing after
	the match. If no match, then kill it by returning 1. */

	for(;adds;adds=adds->rest)
		if(strcmp(prp->nm->varname,adds->prop->nm->varname)==0)
			break;

	if(adds)
	{	
		for(;precs;precs=precs->rest)
			if(checkMatch(precs->prop,prp)) break;

		if(precs)
		{	
			adds = adds->rest;
			return adds;
		}
		else
		{
			return (plptr) 1;
		};
	}
	else
	{
		return (plptr) 1;
	};
};


int
variableResource(char * nm,opptr op)
{
	plptr dels = op->dels;
	plptr adds = op->adds;

	/* Must check whether the predicate appears on the pre and del
	in the same form (an exact match) and on add list. For fixed
	resource each delete list instance must appear as a precondition
	and be matched by one separate instance on the add list */

	for(;dels;dels=dels->rest)
	{
		if(strcmp(dels->prop->nm->varname,nm)==0)
			adds = exactMatch(dels->prop,op->precs,adds);

		if((int)adds==1) break;
	};

	if((int) adds == 1) return 1;

	if(adds==0) return 0;

	for(;adds;adds=adds->rest)
		if(strcmp(adds->prop->nm->varname,nm)==0)
			break;

	return adds!=0;
};				

int
achiever(char * nm,plptr adds)
{
	for(;adds;adds=adds->rest)
		if(strcmp(nm,adds->prop->nm->varname)==0)
			return 1;
	return 0;
};

void
analyse()
{
	predlist tba = allpreds;
	oplistptr ops;

	for(;tba;tba=tba->next)
	{
		for(ops = topdom->ops;ops;ops=ops->ops)
			if(variableResource(tba->name,ops->op)) break;
		
		if(!ops) 
		{
			tba->fr = 1;
		};

		for(ops = topdom->ops;ops;ops=ops->ops)
			if(achiever(tba->name,ops->op->adds))
			{ 
				tba->ar++;
				tba->op = ops->op;
			};
	};
};

/* Procedure to track the objects in the domain. This code preceded use of
PDDL, which provides an explicit list of domain objects in the problem
specification. We continue to extract objects from the rest of the problem
specification and to ignore the objects list. A minor consequence of this
is that objects which have no initial state properties will be lost to the
TIM/STAN system - this means that certain odd domains could prove to have
no plan in STAN (and missing objects in TIM), but this can only occur when
operators have add effects which refer to objects which are not mentioned
in preconditions. These are only sensible in trivial unstructured domains
and don't seem to arise in practice. */

tpptr
insertob(pptr p, tpptr ts)
{	tpptr newp = (tpptr) malloc(sizeof(struct type_decls));
	tpptr ptr = ts;
	tpptr trail = ts;
	int i;
	newp->type = p;
	if (ts == 0)
	{
	 newp->tps = 0;
	 return newp;
	};
	i=strcmp(ts->type->type_name,p->type_name);
	i = i?i:strcmp(ts->type->varname,p->varname);
	if (i==0) {return ts;};
	if (i>0)
	{
		newp->tps = ts;
		return newp;
	}
	else 
	{	ptr = ptr->tps;
		while (ptr != 0)
		{	i=strcmp(ptr->type->type_name,p->type_name);
			i = i?i:strcmp(ptr->type->varname,p->varname);
			if (i==0) {ptr->type->used = p->used; return ts;};
			if (i > 0)
			{	newp->tps = ptr;
				trail->tps = newp;
				return ts;
			};
			trail = ptr;
			ptr=ptr->tps;
		};
		trail->tps = newp;
		newp->tps = 0;
		return ts;
	};
	
};

/* A procedure to track the predicates in the domain: again, this predates
PDDL in which the predicates are explicitly listed. That field of the PDDL
domain spec. is ignored. */

predlist
insertpred(predlist p, propptr theprop, predlist ps)
{
	predlist ptr = ps;
	predlist trail = ps;
	int i;
	plptr newp2;


	if (ps == 0)
	{
	 return p;
	};
	i=strcmp(ps->name,p->name);
	if (i==0)
	{
		if(pstate)
		{
			newp2 = (plptr) malloc(sizeof(struct proplist));
			newp2->rest = ptr->initially;
			newp2->prop = theprop;
			ptr->initially = newp2;

		};
		return ps;
	};
	if (i>0)
	{
		p->next = ps;
		return p;
	}
	else 
	{	ptr = ptr->next;
		while (ptr != 0)
		{	i=strcmp(ptr->name,p->name);
			if (i==0) 
			{
				if(pstate)
				{
					newp2 = (plptr) malloc(sizeof(struct proplist));
					newp2->rest = ptr->initially;
					newp2->prop = theprop;
					ptr->initially = newp2;

				};
				return ps;
			};
			if (i > 0)
			{	p->next = ptr;
				trail->next = p;
				return ps;
			};
			trail = ptr;
			ptr=ptr->next;
		};
		trail->next = p;
		p->next = 0;
		return ps;
	};
	
};


int 
countargs(propptr alist)
{
	int x = 0;
	for(;alist;alist=alist->as) x++;
	return x;
};

pptr 
find(char * v)
{	tpptr ptr = ml;
	while (ptr != 0)
	{	if (strcmp(ptr->type->varname,v)==0)
		{return ptr->type;};
		ptr=ptr->tps;
	};
	printf("missing variable declaration %s\n",v);
	exit(1);
}; 


void
setcurobs(domptr dm,tpptr cos)
{
	dm->obs = cos;
};


/* Procedure used in recording (not (= ..)) preconditions. Note this only
works on variable pairs - no constants. However, the constant abstraction
process will have converted constants into variables inside operators so
there is no problem with this. */

void
adduneqpair(propptr as)
{
	plptr newuneq = (plptr) malloc(sizeof(struct proplist));
	newuneq->prop = as;
	newuneq->rest = uneqpairs;
	uneqpairs = newuneq;
};


/* A range of output procedures - useful for debugging. */
	

void printtype(pptr p)
{	printf("%s",p->varname);
	printf("::");
	printf("%s",p->type_name);
	printf("(%i:%i)",p->type[0],p->type[1]);
};

void printuneqs(uneqlist ueqs)
{
	if(ueqs != 0)
	{
		printf("[");
		while(ueqs)
		{
			printf("%s-",ueqs->uneq->type->varname);
			ueqs=ueqs->next;
		};
		printf("]");
	};
};

void printtypes(tpptr ts)
{	if(ts != 0)
	{	
		while(ts->tps != 0)
		{
			printtype(ts->type);

			printuneqs(ts->uneqs);

			printf(",");
			ts = ts->tps;
		};

		printtype(ts->type);
		printuneqs(ts->uneqs);
	};
};

void printop(opptr o)
{	printtypes(o->vars);	
	printrels(o->precs);
	if(o->statics) 
	{	printf(".."); printrels(o->statics); printf("..");};
	printrels(o->adds);
	printrels(o->dels);
	printpropn(o->thename);
	printf("\n\n");
};


void print(oplistptr os)
{	while(os != 0)
	{	printop(os->op);
		os=os->ops;
	};
};

void printprops(propptr);

void printpropn(propptr p)
{	if(p != 0)
	{	printf("%s",p->nm->varname);
		printprops(p->as);
	};
};

void printprops(propptr p)
{	
	if(p)
	{
		propptr ptr1 = p;
		printf("(");
		while(ptr1->as!=0)
		{	printf("%s",ptr1->nm->varname);
			printf(",");
			ptr1 = ptr1->as;
		};
		printf("%s",ptr1->nm->varname);
		printf(")");
	}
	else
	{
		printf("()");
	};
};

void printrels(plptr rs)
{	plptr ptr = rs;

	printf("[");
	if(ptr == 0){printf("]");}
	else {
		while (ptr->rest != 0)
		{	printpropn(ptr->prop);
			printf(",");
			ptr = ptr->rest;
		};
		printpropn(ptr->prop);
		printf("]");
	};
};

void printdomain(domptr dm)
{	print(dm->ops);
	printrels(dm->initial_state);
	printrels(dm->goal_state);
	printtypes(cur_obs);
};



void 
printresults()
{
	predlist tba = allpreds;

	printf("Fixed resources:\n");

	for(;tba;tba=tba->next)
		printf("%s - %i:%i\n",tba->name,tba->fr,tba->ar);
};

/* In the specification of the grammar that follows, there is a certain amount 
of redundancy and slightly odd structuring. Much of this arises from the fact 
that the parser is a mutation of one intended for a very different language
from PDDL and it was converted in a short time (just before the AIPS'98 planning
competition!). There are probably some much tidier solutions to some of the
minor parsing issues that arise in PDDL, too. */				


#line 858 "pddl.yacc"
typedef union	{
	opptr op;
	plptr pl;
	propptr prp;
	oplistptr olp;
	domptr dom;
	pptr pp;
	tpptr tp;
	char * cp;
	effptr effs;
	int punct;
	} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		173
#define	YYFLAG		-32768
#define	YYNTBASE	31

#define YYTRANSLATE(x) ((unsigned)(x) <= 284 ? yytranslate[x] : 70)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,    15,    30,    35,    41,    47,    48,
    49,    54,    55,    61,    66,    67,    72,    77,    78,    79,
    82,    84,    87,    92,   102,   106,   111,   113,   116,   125,
   128,   131,   135,   137,   140,   143,   147,   155,   158,   160,
   162,   167,   169,   171,   174,   177,   185,   187,   194,   196,
   197,   199,   201,   203,   206,   209,   212,   216,   221,   226,
   227,   229,   232,   233,   235,   238,   240,   243,   246,   249,
   252,   254,   259
};

static const short yyrhs[] = {    32,
     0,    33,     0,    34,     0,     4,    43,     4,    39,    44,
    45,    36,     5,     0,     4,     7,     4,     9,     3,     5,
     4,    35,    39,    12,    41,     5,    46,     5,     0,     8,
    10,     5,     4,     0,     8,    10,    27,     5,     4,     0,
     8,    27,    10,     5,     4,     0,     0,     0,     4,    28,
    37,     5,     0,     0,     4,    30,     3,     5,    38,     0,
     4,    29,     3,     5,     0,     0,     4,    29,     3,     5,
     0,    11,    40,     5,     4,     0,     0,     0,     3,    40,
     0,    42,     0,    41,    42,     0,     4,     3,    62,     5,
     0,     7,     4,    13,     3,     5,     4,    25,     3,     5,
     0,    14,    54,     5,     0,     4,    15,    53,     5,     0,
    47,     0,    46,    47,     0,     4,    16,     3,    17,     4,
    59,    48,     5,     0,    49,    50,     0,     6,    53,     0,
    18,     4,    51,     0,    56,     0,    55,     5,     0,    55,
    51,     0,    22,    55,    51,     0,     4,    23,     4,    27,
    57,     5,     5,     0,     4,     5,     0,    68,     0,    52,
     0,     4,    22,    54,     5,     0,    68,     0,    52,     0,
    68,    54,     0,    52,    54,     0,     4,    23,     4,     3,
    57,     5,     5,     0,    68,     0,    23,     4,     3,    57,
     5,     5,     0,    69,     0,     0,    58,     0,    66,     0,
    67,     0,    58,    66,     0,    58,    67,     0,     5,    60,
     0,    64,     5,    60,     0,    61,    64,     5,    60,     0,
    26,     4,    61,     5,     0,     0,    64,     0,    61,    64,
     0,     0,    65,     0,    63,    65,     0,    65,     0,    63,
    65,     0,    20,     3,     0,    20,     3,     0,    20,     3,
     0,     3,     0,     4,     3,    57,     5,     0,     3,    57,
     5,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   885,   886,   888,   890,   892,   898,   899,   900,   900,   902,
   903,   905,   906,   907,   909,   910,   912,   912,   914,   914,
   916,   916,   918,   920,   922,   924,   926,   927,   929,   932,
   934,   936,   938,   939,   940,   941,   943,   945,   945,   945,
   946,   948,   948,   949,   950,   952,   954,   956,   958,   960,
   961,   963,   964,   965,   966,   968,   969,   970,   972,   973,
   975,   976,   978,   979,   980,   982,   983,   985,   987,   989,
   991,   996,   999
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NAME","OPEN_BRAC",
"CLOSE_BRAC","PRE","DEFINE","REQS","DOMAIN","STRIPS","CONSTANTS","PREDS","PROBLEM",
"INITIALLY","GOALS","ACTION","ARGS","EFFECTS","NOT","Q","STATICS","AND","DEL",
"SITUATION","FORDOMAIN","VARS","EQ","LENGTH","PARALLEL","SERIAL","mystartsymbol",
"domain_desc","the_rest","the_domain","optreqs","opt_length","opt_serial","opt_parallel",
"the_constants","constants","predicates","predicate","the_problem","init","goals",
"opreps","oprep","conditions","prerels","effectrels","mixed_relations","prelation",
"relations","lots_of_relations","erelation","single_erelation","args","arglist",
"varlist","morevars","fullvarlist","pvarlist","fullpvarlist","variable_decl",
"pvariable_decl","variable","constant","relation","single_relation", NULL
};
#endif

static const short yyr1[] = {     0,
    31,    31,    32,    33,    34,    35,    35,    35,    35,    36,
    36,    37,    37,    37,    38,    38,    39,    39,    40,    40,
    41,    41,    42,    43,    44,    45,    46,    46,    47,    48,
    49,    50,    51,    51,    51,    51,    52,    53,    53,    53,
    53,    54,    54,    54,    54,    55,    55,    56,    56,    57,
    57,    58,    58,    58,    58,    59,    59,    59,    60,    60,
    61,    61,    62,    62,    62,    63,    63,    64,    65,    66,
    67,    68,    69
};

static const short yyr2[] = {     0,
     1,     1,     1,     8,    14,     4,     5,     5,     0,     0,
     4,     0,     5,     4,     0,     4,     4,     0,     0,     2,
     1,     2,     4,     9,     3,     4,     1,     2,     8,     2,
     2,     3,     1,     2,     2,     3,     7,     2,     1,     1,
     4,     1,     1,     2,     2,     7,     1,     6,     1,     0,
     1,     1,     1,     2,     2,     2,     3,     4,     4,     0,
     1,     2,     0,     1,     2,     1,     2,     2,     2,     2,
     1,     4,     3
};

static const short yydefact[] = {     0,
     0,     1,     2,     3,     0,     0,     0,    18,     0,     0,
    19,     0,     0,     0,    19,     0,     0,     0,     0,     0,
    20,     0,     0,    43,     0,    42,     0,    10,     9,     0,
    17,    50,     0,    45,    25,    44,     0,     0,     0,     0,
    18,     0,    71,     0,     0,    51,    52,    53,     0,     0,
    40,     0,    39,    12,     4,     0,     0,     0,     0,    70,
    72,    54,    55,    50,    38,     0,    26,     0,     0,     0,
     0,     0,     0,    24,     0,     0,     0,     0,    11,     6,
     0,     0,     0,     0,    21,     0,    41,     0,     0,     7,
     8,    63,     0,    22,    37,    14,    15,     0,     0,     0,
    64,     0,     0,    27,     0,    13,    69,    23,    65,     0,
     5,    28,     0,     0,     0,     0,    16,     0,    60,     0,
     0,     0,    61,     0,    56,    68,     0,     0,     0,    62,
    60,     0,    31,    29,     0,    30,    60,    57,     0,    61,
     0,    58,    59,    62,    50,     0,     0,     0,    32,     0,
    33,    47,    49,     0,     0,     0,     0,    34,    35,    73,
     0,    36,    50,    50,     0,     0,     0,     0,    48,    46,
     0,     0,     0
};

static const short yydefgoto[] = {   171,
     2,     3,     4,    41,    39,    69,   106,    12,    16,    84,
    85,     6,    18,    28,   103,   104,   128,   129,   136,   149,
    24,    52,    25,   150,   151,    45,    46,   121,   125,   122,
    99,   100,   123,   101,    47,    48,    26,   153
};

static const short yypact[] = {    34,
    36,-32768,-32768,-32768,    42,    47,    26,    41,    50,    51,
    52,    43,    53,    54,    52,    55,    57,    58,    59,    60,
-32768,    61,     9,    57,    62,    57,    56,    64,    48,    44,
-32768,     3,    66,-32768,-32768,-32768,    68,    38,    69,    10,
    41,    70,-32768,    72,    71,     3,-32768,-32768,    67,     8,
-32768,    73,-32768,    75,-32768,    -1,    74,    65,    76,-32768,
-32768,-32768,-32768,     3,-32768,    57,-32768,   -11,    78,    81,
    82,    83,    85,-32768,    86,    88,    77,    92,-32768,-32768,
    93,    94,    96,    17,-32768,    91,-32768,    97,    98,-32768,
-32768,    87,   101,-32768,-32768,-32768,   102,   105,   104,    87,
    95,   100,    45,-32768,    89,-32768,-32768,-32768,   103,   108,
-32768,-32768,   109,   107,   112,   110,-32768,    20,    99,   117,
    80,   106,   116,   118,-32768,-32768,    68,   122,   111,   123,
    99,   106,-32768,-32768,   126,-32768,    99,-32768,    24,-32768,
    11,-32768,-32768,-32768,     3,    13,   127,   128,-32768,     5,
-32768,-32768,-32768,   129,   131,    11,   130,-32768,-32768,-32768,
   133,-32768,     3,     3,   132,   134,   135,   136,-32768,-32768,
   138,   142,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   113,   137,-32768,
    63,-32768,-32768,-32768,-32768,    40,-32768,-32768,-32768,  -109,
   -35,    18,   -21,    -3,-32768,   -63,-32768,-32768,   -89,    14,
-32768,-32768,  -115,    49,   114,   115,   -37,-32768
};


#define	YYLAST		161


static const short yytable[] = {    53,
    75,    51,    34,    70,    36,    43,   130,   145,   146,   158,
    32,    32,    65,   145,   146,    32,   140,    77,    78,    56,
    83,    93,    44,   144,   119,    71,   147,   148,   143,    66,
    33,    33,   147,   148,     9,   155,    57,     1,    10,   120,
   159,   138,     5,   120,    76,     7,   162,   142,   102,   111,
     8,    11,    13,    14,    15,    40,    17,    19,    20,    22,
    23,    27,    29,    30,    31,    54,    35,    38,    42,    49,
    37,    50,    59,    55,    60,    61,    73,    67,    68,    88,
    74,   154,    79,    72,    80,   127,    81,    82,    83,    53,
    86,    51,    87,    64,    89,    95,    90,    91,    92,   165,
   166,    96,    97,   152,   102,   105,    98,   107,   108,   152,
   114,   115,   152,   118,   -66,   110,   117,   113,   152,   126,
   131,   132,   -67,   116,   124,   120,   134,   137,   135,   141,
   146,   157,   163,   160,   161,   164,   167,   172,   168,   169,
   170,   173,   112,   156,   133,   139,    94,     0,   109,     0,
     0,    21,     0,    58,     0,     0,     0,     0,     0,    62,
    63
};

static const short yycheck[] = {    37,
    64,    37,    24,     5,    26,     3,   122,     3,     4,     5,
     3,     3,     5,     3,     4,     3,   132,    29,    30,    10,
     4,     5,    20,   139,     5,    27,    22,    23,     5,    22,
    23,    23,    22,    23,     9,    23,    27,     4,    13,    20,
   150,   131,     7,    20,    66,     4,   156,   137,     4,     5,
     4,    11,     3,     3,     3,     8,    14,     5,     5,     5,
     4,     4,     4,     4,     4,    28,     5,     4,    25,     4,
    15,     4,     3,     5,     3,     5,    12,     5,     4,     3,
     5,   145,     5,    10,     4,     6,     5,     5,     4,   127,
     5,   127,     5,    27,     3,     5,     4,     4,     3,   163,
   164,     5,     5,   141,     4,     4,    20,     3,     5,   147,
     3,     3,   150,     4,    20,    16,     5,    29,   156,     3,
     5,     4,    20,    17,    26,    20,     5,     5,    18,     4,
     4,     4,     3,     5,     4,     3,     5,     0,     5,     5,
     5,     0,   103,   147,   127,   132,    84,    -1,   100,    -1,
    -1,    15,    -1,    41,    -1,    -1,    -1,    -1,    -1,    46,
    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 885 "pddl.yacc"
{yyval.dom=yyvsp[0].dom;topdom=yyvsp[0].dom;;
    break;}
case 2:
#line 886 "pddl.yacc"
{yyval.dom=yyvsp[0].dom;setcurobs(yyvsp[0].dom,cur_obs);analyse();;
    break;}
case 3:
#line 888 "pddl.yacc"
{yyval.dom = make_domain(yyvsp[0].olp,0,0);;
    break;}
case 4:
#line 890 "pddl.yacc"
{yyval.dom = add_to_domain(yyvsp[-3].pl,yyvsp[-2].pl);;
    break;}
case 5:
#line 896 "pddl.yacc"
{yyval.olp = yyvsp[-1].olp; dname = yyvsp[-9].cp;;
    break;}
case 6:
#line 898 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 7:
#line 899 "pddl.yacc"
{;yyval.punct=0;;
    break;}
case 8:
#line 900 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 9:
#line 900 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 10:
#line 902 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 11:
#line 903 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 12:
#line 905 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 13:
#line 906 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 14:
#line 907 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 15:
#line 909 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 16:
#line 910 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 17:
#line 912 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 18:
#line 912 "pddl.yacc"
{yyval.punct=0;;
    break;}
case 19:
#line 914 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 20:
#line 914 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 21:
#line 916 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 22:
#line 916 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 23:
#line 918 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 24:
#line 920 "pddl.yacc"
{if(strcmp(yyvsp[-1].cp,dname)) {perror("Problem not for this domain!\n"); exit(1);};pname = yyvsp[-5].cp;finishOps();;
    break;}
case 25:
#line 922 "pddl.yacc"
{yyval.pl = yyvsp[-1].pl;;
    break;}
case 26:
#line 924 "pddl.yacc"
{yyval.pl = yyvsp[-1].pl;;
    break;}
case 27:
#line 926 "pddl.yacc"
{yyval.olp = setset(yyvsp[0].op,0);;
    break;}
case 28:
#line 927 "pddl.yacc"
{yyval.olp = setset(yyvsp[0].op,yyvsp[-1].olp);;
    break;}
case 29:
#line 930 "pddl.yacc"
{yyval.op = setop(ml,setopname(yyvsp[-5].cp,yyvsp[-2].tp,yyvsp[-1].op));;
    break;}
case 30:
#line 932 "pddl.yacc"
{yyval.op = setoprels(yyvsp[-1].pl,yyvsp[0].effs->adds,yyvsp[0].effs->dels);free(yyvsp[0].effs);;
    break;}
case 31:
#line 934 "pddl.yacc"
{yyval.pl = yyvsp[0].pl;;
    break;}
case 32:
#line 936 "pddl.yacc"
{yyval.effs = yyvsp[0].effs;;
    break;}
case 33:
#line 938 "pddl.yacc"
{yyval.effs = yyvsp[0].effs;;
    break;}
case 34:
#line 939 "pddl.yacc"
{yyval.effs = yyvsp[-1].effs;;
    break;}
case 35:
#line 940 "pddl.yacc"
{yyval.effs = setelist(yyvsp[0].effs,yyvsp[-1].effs);;
    break;}
case 36:
#line 941 "pddl.yacc"
{yyval.effs = setelist(yyvsp[0].effs,yyvsp[-1].effs);;
    break;}
case 37:
#line 943 "pddl.yacc"
{adduneqpair(yyvsp[-2].prp);;
    break;}
case 38:
#line 945 "pddl.yacc"
{yyval.pl=0;;
    break;}
case 39:
#line 945 "pddl.yacc"
{yyval.pl = setplist(0,yyvsp[0].prp);;
    break;}
case 40:
#line 945 "pddl.yacc"
{yyval.pl = 0;;
    break;}
case 41:
#line 946 "pddl.yacc"
{yyval.pl=yyvsp[-1].pl;;
    break;}
case 42:
#line 948 "pddl.yacc"
{yyval.pl = setplist(0,yyvsp[0].prp);;
    break;}
case 43:
#line 948 "pddl.yacc"
{yyval.pl = 0;;
    break;}
case 44:
#line 949 "pddl.yacc"
{yyval.pl = setplist(yyvsp[0].pl,yyvsp[-1].prp);;
    break;}
case 45:
#line 950 "pddl.yacc"
{yyval.pl = yyvsp[0].pl;;
    break;}
case 46:
#line 953 "pddl.yacc"
{yyval.effs = setdel(setpropn(setpair(yyvsp[-3].cp,0),yyvsp[-2].prp));;
    break;}
case 47:
#line 954 "pddl.yacc"
{yyval.effs = setadd(yyvsp[0].prp);;
    break;}
case 48:
#line 957 "pddl.yacc"
{yyval.effs = setdel(setpropn(setpair(yyvsp[-3].cp,0),yyvsp[-2].prp));;
    break;}
case 49:
#line 958 "pddl.yacc"
{yyval.effs = setadd(yyvsp[0].prp);;
    break;}
case 50:
#line 960 "pddl.yacc"
{yyval.prp = 0;;
    break;}
case 51:
#line 961 "pddl.yacc"
{yyval.prp = yyvsp[0].prp;;
    break;}
case 52:
#line 963 "pddl.yacc"
{yyval.prp = setpropnargs(yyvsp[0].pp,0);;
    break;}
case 53:
#line 964 "pddl.yacc"
{yyval.prp = setpropnargs(yyvsp[0].pp,0);;
    break;}
case 54:
#line 965 "pddl.yacc"
{yyval.prp = setpropnargs(yyvsp[0].pp,yyvsp[-1].prp);;
    break;}
case 55:
#line 966 "pddl.yacc"
{yyval.prp = setpropnargs(yyvsp[0].pp,yyvsp[-1].prp);;
    break;}
case 56:
#line 968 "pddl.yacc"
{uneqpairs = 0;yyval.tp = yyvsp[0].tp;ml = yyvsp[0].tp;vl=0;;
    break;}
case 57:
#line 969 "pddl.yacc"
{uneqpairs = 0;yyval.tp = setdecls(yyvsp[-2].pp,yyvsp[0].tp);ml = yyval.tp;vl = setdecls(yyvsp[-2].pp,0);;
    break;}
case 58:
#line 970 "pddl.yacc"
{uneqpairs = 0;vl = setdecls(yyvsp[-2].pp,yyvsp[-3].tp);yyval.tp = appendvars(vl,yyvsp[0].tp);ml = yyval.tp;;
    break;}
case 59:
#line 972 "pddl.yacc"
{yyval.tp = yyvsp[-1].tp;;
    break;}
case 60:
#line 973 "pddl.yacc"
{yyval.tp = 0;;
    break;}
case 61:
#line 975 "pddl.yacc"
{uneqpairs = 0;yyval.tp = setdecls(yyvsp[0].pp,0);ml = yyval.tp;;
    break;}
case 62:
#line 976 "pddl.yacc"
{uneqpairs = 0;yyval.tp = setdecls(yyvsp[0].pp,yyvsp[-1].tp);ml = yyval.tp;;
    break;}
case 63:
#line 978 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 64:
#line 979 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 65:
#line 980 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 66:
#line 982 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 67:
#line 983 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 68:
#line 985 "pddl.yacc"
{yyval.pp = setpair(yyvsp[0].cp,notype);;
    break;}
case 69:
#line 987 "pddl.yacc"
{yyval.punct = 0;;
    break;}
case 70:
#line 989 "pddl.yacc"
{yyval.pp = find(yyvsp[0].cp);;
    break;}
case 71:
#line 991 "pddl.yacc"
{yyval.pp = setpair(yyvsp[0].cp,notype); 
			   markUsedInOp(yyval.pp);
			   cur_obs = insertob(yyval.pp,cur_obs); 	
			yyval.pp=addextraprop(yyval.pp);;
    break;}
case 72:
#line 996 "pddl.yacc"
{yyval.prp = setpropn(setpair(yyvsp[-2].cp,0),yyvsp[-1].prp);
			   allpreds = insertpred(setpred(yyvsp[-2].cp,countargs(yyvsp[-1].prp)),yyval.prp,allpreds);;
    break;}
case 73:
#line 999 "pddl.yacc"
{yyval.prp = setpropn(setpair(yyvsp[-2].cp,0),yyvsp[-1].prp);
			   allpreds = insertpred(setpred(yyvsp[-2].cp,countargs(yyvsp[-1].prp)),yyval.prp,allpreds);;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1004 "pddl.yacc"

#include <stdio.h>
int lineno = 0;
extern int fileno();
#include "lex.yy.c"

int yyerror(char * s)
{
 fprintf(stderr,"%s\n",s);
 fprintf(stderr,"Error occurred at or near line %i\n",lineno);

/* This is a very primitive error reporting "service"! */

 exit(1);

 return 0;
}
